module polydiv2
  use adj_mod
  use helix
  use polydiv
  implicit none
  logical, parameter, private :: T = .true., F = .false.
  type( filter), private :: aa,bb
  integer :: nd
contains
  subroutine polydiv2_init (nd_in,aa_in,bb_in)
    type( filter)    :: aa_in, bb_in
    integer          :: nd_in
    nd = nd_in
    aa = aa_in
    bb = bb_in
  end subroutine polydiv2_init
  function polydiv2_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    real, dimension (size (xx)) :: tt
    tt=0.
    call adjnull (adj,add,xx,yy)
    if (adj) then
       call polydiv_init(nd,bb)
       call polydiv_lop2(T,tt,yy)
       call polydiv_init(nd,aa)
       call polydiv_lop2(T,xx,tt)
    else
       call polydiv_init(nd,aa)
       call polydiv_lop2(F,xx,tt)
       call polydiv_init(nd,bb)
       call polydiv_lop2(F,tt,yy)
    end if
    stat=0
  end function polydiv2_lop
end module polydiv2
