module helicon2
  use adj_mod
  use helix
  use helicon
  implicit none
  logical, parameter, private :: T = .true., F = .false.
  type( filter), private :: aa,bb
contains
  subroutine helicon2_init (aa_in,bb_in)
    type( filter)    :: aa_in, bb_in
    aa = aa_in
    bb = bb_in
  end subroutine helicon2_init
  function helicon2_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    real, dimension (size (xx)) :: tt
    tt=0.

    call adjnull (adj,add,xx,yy)
    if (adj) then
       call helicon_init(bb)
       call helicon_lop2(T,tt,yy)
       call helicon_init(aa)
       call helicon_lop2(T,xx,tt)
    else
       call helicon_init(aa)
       call helicon_lop2(F,xx,tt)
       call helicon_init(bb)
       call helicon_lop2(F,tt,yy)
    end if

    stat=0
  end function helicon2_lop
end module helicon2
